diff -ruN qmail-1.03-orig/alloc.c qmail-1.03-ldap-20060201-orig/alloc.c
--- qmail-1.03-orig/alloc.c	1998-06-15 12:53:16.000000000 +0200
+++ qmail-1.03-ldap-20060201-orig/alloc.c	2006-02-25 11:00:55.000000000 +0100
@@ -1,32 +1,18 @@
+#include <stdlib.h>
 #include "alloc.h"
 #include "error.h"
-extern char *malloc();
-extern void free();
 
-#define ALIGNMENT 16 /* XXX: assuming that this alignment is enough */
-#define SPACE 4096 /* must be multiple of ALIGNMENT */
-
-typedef union { char irrelevant[ALIGNMENT]; double d; } aligned;
-static aligned realspace[SPACE / ALIGNMENT];
-#define space ((char *) realspace)
-static unsigned int avail = SPACE; /* multiple of ALIGNMENT; 0<=avail<=SPACE */
-
-/*@null@*//*@out@*/char *alloc(n)
+/*@null@*//*@out@*/void *alloc(n)
 unsigned int n;
 {
-  char *x;
-  n = ALIGNMENT + n - (n & (ALIGNMENT - 1)); /* XXX: could overflow */
-  if (n <= avail) { avail -= n; return space + avail; }
+  void *x;
   x = malloc(n);
   if (!x) errno = error_nomem;
   return x;
 }
 
 void alloc_free(x)
-char *x;
+void *x;
 {
-  if (x >= space)
-    if (x < space + SPACE)
-      return; /* XXX: assuming that pointers are flat */
   free(x);
 }
diff -ruN qmail-1.03-orig/alloc.h qmail-1.03-ldap-20060201-orig/alloc.h
--- qmail-1.03-orig/alloc.h	1998-06-15 12:53:16.000000000 +0200
+++ qmail-1.03-ldap-20060201-orig/alloc.h	2006-02-25 11:00:55.000000000 +0100
@@ -1,8 +1,8 @@
 #ifndef ALLOC_H
 #define ALLOC_H
 
-extern /*@null@*//*@out@*/char *alloc();
-extern void alloc_free();
-extern int alloc_re();
+extern /*@null@*//*@out@*/void *alloc(unsigned int);
+extern void alloc_free(void *);
+extern int alloc_re(char **, unsigned int, unsigned int);
 
 #endif
diff -ruN qmail-1.03-orig/auth_imap.c qmail-1.03-ldap-20060201-orig/auth_imap.c
--- qmail-1.03-orig/auth_imap.c	1970-01-01 01:00:00.000000000 +0100
+++ qmail-1.03-ldap-20060201-orig/auth_imap.c	2006-02-25 11:00:55.000000000 +0100
@@ -0,0 +1,354 @@
+/*
+ * Copyright (c) 2000-2004 Claudio Jeker,
+ *      Internet Business Solutions AG, CH-8005 Zürich, Switzerland
+ *
+ * Redistribution and use in source and binary forms, with or without
+ * modification, are permitted provided that the following conditions
+ * are met:
+ * 1. Redistributions of source code must retain the above copyright
+ *    notice, this list of conditions and the following disclaimer.
+ * 2. Redistributions in binary form must reproduce the above copyright
+ *    notice, this list of conditions and the following disclaimer in the
+ *    documentation and/or other materials provided with the distribution.
+ * 3. All advertising materials mentioning features or use of this software
+ *    must display the following acknowledgement:
+ *      This product includes software developed by Internet Business
+ *      Solutions AG and its contributors.
+ * 4. Neither the name of the author nor the names of its contributors
+ *    may be used to endorse or promote products derived from this software
+ *    without specific prior written permission.
+ *
+ * THIS SOFTWARE IS PROVIDED BY THE AUTHORS AND CONTRIBUTORS ``AS IS'' AND
+ * ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE
+ * IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE
+ * ARE DISCLAIMED.  IN NO EVENT SHALL THE AUTHORS OR CONTRIBUTORS BE LIABLE
+ * FOR ANY DIRECT, INDIRECT, INCIDENTAL, SPECIAL, EXEMPLARY, OR CONSEQUENTIAL
+ * DAMAGES (INCLUDING, BUT NOT LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS
+ * OR SERVICES; LOSS OF USE, DATA, OR PROFITS; OR BUSINESS INTERRUPTION)
+ * HOWEVER CAUSED AND ON ANY THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT
+ * LIABILITY, OR TORT (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY
+ * OUT OF THE USE OF THIS SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF
+ * SUCH DAMAGE.
+ *
+ */
+
+/* auth_imap.c for courier-imap */
+#include <sys/types.h>
+#include <sys/wait.h>
+#include <errno.h>
+#include <unistd.h>
+#include "alloc.h"
+#include "byte.h"
+#include "env.h"
+#include "error.h"
+#include "exit.h"
+#include "fmt.h"
+#include "pbsexec.h"
+#include "qldap-debug.h"
+#include "qldap-errno.h"
+#include "qmail-ldap.h"
+#include "readwrite.h"
+#include "scan.h"
+#include "sgetopt.h"
+#include "sig.h"
+#include "str.h"
+#include "stralloc.h"
+#include "substdio.h"
+#include "timeoutread.h"
+
+#include "auth_mod.h"
+
+#ifndef PORT_IMAP /* this is for testing purposes */
+#define PORT_IMAP	143
+#endif
+
+const unsigned int auth_port = PORT_IMAP;
+
+#define UP_LEN 1024
+static char auth_up[UP_LEN];
+static unsigned int auth_uplen;
+static int auth_argc;
+static char **auth_argv;
+
+void
+auth_init(int argc, char **argv, stralloc *login, stralloc *authdata)
+{
+	char		*a, *s, *t, *l, *p;
+	int		 waitstat, opt, n;
+	unsigned int	 u;
+
+	while ((opt = getopt(argc, argv, "d:")) != opteof) {
+		switch (opt) {
+		case 'd':
+			pbstool = optarg;
+			break;
+		default:
+			auth_error(AUTH_CONF);
+		}
+	}
+	argc -= optind;
+	argv += optind;
+
+	if (argc < 1)
+		auth_error(AUTH_CONF);
+	auth_argc = argc;
+	auth_argv = argv;
+
+	a = env_get("AUTHENTICATED");
+	if (a && *a) {  /* Already a good guy */
+		logit(8, "auth_init: allready authenticated\n");
+		execvp(*argv, argv);
+		auth_error(AUTH_EXEC);
+	}
+	
+#if 1
+	/*
+	 * remove all zombies, why should I do that?
+	 * Because courier makes zombies for breakfast
+	 */
+	sig_childdefault();
+	while (wait(&waitstat) >= 0) ;
+#endif
+	for (auth_uplen = 0;;) {
+		do {
+			n = read(3, auth_up + auth_uplen,
+			    sizeof(auth_up) - auth_uplen);
+		} while ((n == -1) && (errno == EINTR));
+		if (n == -1)
+			auth_error(ERRNO);
+		if (n == 0) break;
+		auth_uplen += n;
+		if (auth_uplen >= sizeof(auth_up)) {
+			auth_error(PANIC);
+		}
+	}
+	close(3);
+	auth_up[auth_uplen] = '\0';
+	
+	/*
+	 * get the different fields: service<NL>AUTHTYPE<NL>AUTHDATA
+	 */
+	u = 0;
+	s = auth_up; /* ignore service field */
+	while (auth_up[u] && auth_up[u] != '\n' ) u++;
+	if (u >= auth_uplen)
+		auth_error(NEEDED);
+	auth_up[u++] = '\0';
+	t = auth_up + u; /* type has to be "login" else fail ... */
+	while (auth_up[u] && auth_up[u] != '\n' ) u++;
+	if (u >= auth_uplen)
+		auth_error(NEEDED);
+	auth_up[u++] = '\0';
+	if (str_diff("login", t)) {
+		/* 
+		 * this modul supports only "login"-type,
+		 * fail with AUTH_TYPE, so the 
+		 * next modul is called, perhaps with greater success
+		 */
+		auth_fail("unknown", AUTH_TYPE);
+	}
+	l = auth_up + u; /* next login */
+	while (auth_up[u] && auth_up[u] != '\n' ) u++;
+	if (u >= auth_uplen)
+		auth_error(NEEDED);
+	auth_up[u++] = '\0';
+	p = auth_up + u; /* and the password */
+	while (auth_up[u] && auth_up[u] != '\n' ) u++;
+	if (u >= auth_uplen)
+		auth_error(NEEDED);
+	auth_up[u++] = '\0';
+	if (u > auth_uplen) /* paranoia */
+		auth_error(NEEDED);
+
+	/* copy the login and password into the coresponding structures */
+	if (!stralloc_copys(login, l))
+		auth_error(ERRNO);
+	if (!stralloc_0(login))
+		auth_error(ERRNO);
+
+	if (!stralloc_copys(authdata, p))
+		auth_error(ERRNO);
+	if (!stralloc_0(authdata))
+		auth_error(ERRNO);
+}
+
+void
+auth_fail(const char *login, int reason)
+{
+	unsigned int	 i;
+	int		 pi[2], n;
+	char		*t = auth_up;
+	
+	logit(2, "warning: auth_fail: user %s failed\n", login);
+	if (reason == NOSUCH || reason == AUTH_TYPE) {
+		logit(4, "warning: auth_fail: %s\n", qldap_err_str(reason));
+		if (!env_unset("AUTHENTICATED"))
+			auth_error(ERRNO);
+		for (i=0; i < auth_uplen; i++)
+			if (!auth_up[i])
+				auth_up[i] = '\n';
+		close(3);
+		if (pipe(pi) == -1)
+			auth_error(ERRNO);
+		if (pi[0] != 3) /* be serious, we closed 3 so ... */
+			auth_error(PANIC);
+		switch (fork()) {
+		case -1:
+			auth_error(ERRNO);
+		case 0:
+			break;
+		default: /* parent process */
+			close(pi[1]);
+			sig_pipedefault();
+			/* start next auth module */
+			execvp(*auth_argv, auth_argv);
+			auth_error(AUTH_EXEC);
+		}
+		/* child process */
+		close(pi[0]);
+		while (auth_uplen) {
+			n = subwrite(pi[1],t,auth_uplen);
+			if (n == -1) {
+				if (errno == error_intr) continue;
+				/* note that some data may have been written */
+			}
+			t += n;
+			auth_uplen -= n;
+		}
+		byte_zero(auth_up, sizeof(auth_up));
+		close(pi[1]);
+		_exit(0);
+	}
+	auth_error(reason); /* complete failure */
+}
+
+void
+auth_success(const char *login)
+{
+	byte_zero(auth_up, sizeof(auth_up));
+	
+	/* pop befor smtp */
+	pbsexec();
+	
+	/* start imap process */
+	execvp(*auth_argv, auth_argv);
+
+	auth_error(AUTH_EXEC);
+	/* end */
+}
+
+void auth_error(int errnum)
+{
+	char envname[FMT_ULONG+8];
+	char *env, *n, *n2;
+	char **argvs;
+	unsigned long numarg, i;
+	
+	/* XXX under courier-imap it is not simple to give the correct failure
+	 * XXX back to the user, perhaps somebody has a good idea */
+
+	byte_zero(auth_up, sizeof(auth_up));
+	
+	logit(2, "warning: auth_error: authorization failed (%s)\n",
+		   qldap_err_str(errnum));
+	if (!(env = env_get("AUTHARGC")))
+		_exit(111);
+	scan_ulong(env, &numarg);
+	argvs = (char **) alloc((numarg+1) * sizeof(char *));
+	n = envname;
+	n += fmt_str(n, "AUTHARGV");
+	for (i = 0; i < numarg; i++) {
+		n2 = n;
+		n2 += fmt_ulong(n2, i);
+		*n2 = 0;
+		if (!(argvs[i] = env_get(envname)))
+			_exit(111);
+	}
+	argvs[i+1] = (char *)0;
+#if 0
+	/*
+	 * can no longer find AUTHUSER in authlib(7) of courier-imap 1.7.2
+	 * but it still exists. So what should I do? Drop my pants?
+	 */
+	if (!(env = env_get("AUTHUSER")))
+		_exit(100);
+#endif
+	execv(*argvs, argvs);
+	_exit(111);
+	
+}
+
+char *
+auth_aliasempty(void)
+{
+	if (auth_argc > 0)
+		return auth_argv[auth_argc-1];
+	return (char *)0;
+}
+
+#ifdef QLDAP_CLUSTER
+static void get_ok(int , const char *);
+
+static void
+get_ok(int fd, const char *tag)
+/* get the ok for the next command, wait for "[TAG] OK.*\r\n" */
+/* This should work (Idea from RFC 1730 and fetchmail) */
+{
+#define AUTH_TIMEOUT 10 /* 10 sec timeout */
+#define OK_LEN 8192+1
+	char ok[OK_LEN];
+	char *s;
+	unsigned char x;
+	int  len;
+	int  i;
+
+	if (!tag) return; /* bad pointer */
+	do {
+		len = timeoutread(AUTH_TIMEOUT, fd, ok, sizeof(ok) - 1);
+		if (len == -1)
+			auth_error(ERRNO);
+		ok[len] = '\0';
+		/* upper case all */
+		for (i = 0, s = ok; i < len; i++) {
+			x = *s - 'a';
+			if ( x <= 'z' - 'a' ) *s = x + 'A';
+			s++;
+		}
+	} while (str_diffn(ok, tag, str_len(tag)));
+	/* tag found, next check for OK */
+	s = ok + str_len(tag); /* skip tag */
+	while (*s == ' ' || *s == '\t') s++; /* skip all spaces */
+	
+	if (str_diffn(s, "OK", 2) == 0 ) return;
+	else if (str_diffn(s, "BAD", 3) == 0 || str_diffn(s, "NO", 2) == 0)
+		/* other server not happy */
+		auth_error(BADCLUSTER);
+	/* ARRG, this server talks not my dialect */
+	auth_error(BADCLUSTER);
+}
+
+void
+auth_forward(int fd, char *login, char *passwd)
+{
+	char *tag;
+	substdio ss;
+	char buf[512];
+	
+	tag = env_get("IMAPLOGINTAG");
+	if (!(tag && *tag))
+		/* UH OH, no imap tag, how could that be ? */
+		auth_error(PANIC);
+	
+	get_ok(fd, "*");
+	substdio_fdbuf(&ss,subwrite,fd,buf,sizeof(buf));
+	substdio_puts(&ss, tag);
+	substdio_puts(&ss, " login "); 
+	substdio_puts(&ss, login); 
+	substdio_puts(&ss, " ");
+	substdio_puts(&ss, passwd); 
+	substdio_puts(&ss, "\r\n");
+	substdio_flush(&ss);
+}
+
+#endif /* QLDAP_CLUSTER */
+
diff -ruN qmail-1.03-orig/auth_mod.c qmail-1.03-ldap-20060201-orig/auth_mod.c
--- qmail-1.03-orig/auth_mod.c	1970-01-01 01:00:00.000000000 +0100
+++ qmail-1.03-ldap-20060201-orig/auth_mod.c	2006-02-25 11:00:55.000000000 +0100
@@ -0,0 +1,392 @@
+/*
+ * Copyright (c) 2003-2004 Claudio Jeker,
+ *      Internet Business Solutions AG, CH-8005 Zürich, Switzerland
+ *
+ * Redistribution and use in source and binary forms, with or without
+ * modification, are permitted provided that the following conditions
+ * are met:
+ * 1. Redistributions of source code must retain the above copyright
+ *    notice, this list of conditions and the following disclaimer.
+ * 2. Redistributions in binary form must reproduce the above copyright
+ *    notice, this list of conditions and the following disclaimer in the
+ *    documentation and/or other materials provided with the distribution.
+ * 3. All advertising materials mentioning features or use of this software
+ *    must display the following acknowledgement:
+ *      This product includes software developed by Internet Business
+ *      Solutions AG and its contributors.
+ * 4. Neither the name of the author nor the names of its contributors
+ *    may be used to endorse or promote products derived from this software
+ *    without specific prior written permission.
+ *
+ * THIS SOFTWARE IS PROVIDED BY THE AUTHORS AND CONTRIBUTORS ``AS IS'' AND
+ * ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE
+ * IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE
+ * ARE DISCLAIMED.  IN NO EVENT SHALL THE AUTHORS OR CONTRIBUTORS BE LIABLE
+ * FOR ANY DIRECT, INDIRECT, INCIDENTAL, SPECIAL, EXEMPLARY, OR CONSEQUENTIAL
+ * DAMAGES (INCLUDING, BUT NOT LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS
+ * OR SERVICES; LOSS OF USE, DATA, OR PROFITS; OR BUSINESS INTERRUPTION)
+ * HOWEVER CAUSED AND ON ANY THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT
+ * LIABILITY, OR TORT (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY
+ * OUT OF THE USE OF THIS SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF
+ * SUCH DAMAGE.
+ *
+ */
+#include <sys/types.h>
+#include <unistd.h>
+#include "alloc.h"
+#include "byte.h"
+#include "error.h"
+#include "localdelivery.h"
+#include "locallookup.h"
+#include "output.h"
+#include "pbsexec.h"
+#include "qldap.h"
+#include "qldap-debug.h"
+#include "qldap-errno.h"
+#include "read-ctrl.h"
+#include "readwrite.h"
+#include "stralloc.h"
+#ifdef QLDAP_CLUSTER
+#include <sys/socket.h>
+#include "dns.h"
+#include "ipalloc.h"
+#include "ipme.h"
+#include "ndelay.h"
+#include "qldap-cluster.h"
+#include "select.h"
+#include "timeoutconn.h"
+#endif
+#ifdef AUTOHOMEDIRMAKE
+#include "dirmaker.h"
+#endif
+#ifdef AUTOMAILDIRMAKE
+#include "mailmaker.h"
+#endif
+
+
+#include "checkpassword.h"
+#include "auth_mod.h"
+
+stralloc	loginstr = {0};
+stralloc	authdatastr = {0};
+
+ctrlfunc	ctrls[] = {
+		qldap_ctrl_login,
+		qldap_ctrl_generic,
+		localdelivery_init,
+#ifdef QLDAP_CLUSTER
+		cluster_init,
+#endif
+#ifdef AUTOHOMEDIRMAKE
+		dirmaker_init,
+#endif		
+		0 };
+
+checkfunc	cfuncs[] = {
+	check_ldap,
+	check_passwd,
+	0
+};
+
+void chdir_or_make(char *, char *);
+
+#ifdef QLDAP_CLUSTER
+void forward(char *, char *, struct credentials *);
+#endif
+
+int
+main(int argc, char **argv)
+{
+	struct	credentials c;
+	int r;
+
+	log_init(STDERR, ~256, 0);	/* XXX limited so that it is not
+					   possible to get passwords via 
+					   debug on production systems.
+					 */
+	if (read_controls(ctrls) == -1)
+		auth_error(AUTH_CONF);
+
+	auth_init(argc, argv, &loginstr, &authdatastr);
+	logit(256, "auth_init: login=%s, authdata=%s\n",
+	    loginstr.s, authdatastr.s);
+
+	if (authdatastr.len <= 1) {
+		logit(1, "alert: null password.\n");
+		auth_fail(loginstr.s, BADPASS);
+	}
+	
+	byte_zero(&c, sizeof(c));
+	r = check(cfuncs, &loginstr, &authdatastr, &c, 0);
+	switch (r) {
+	case OK:
+		/* authdata no longer needed */
+		byte_zero(authdatastr.s, authdatastr.len);
+		change_uid(c.uid, c.gid);
+		setup_env(loginstr.s, &c);
+		chdir_or_make(c.home.s, c.maildir.s);
+		auth_success(loginstr.s);
+	case FORWARD:
+#ifdef QLDAP_CLUSTER
+		change_uid(-1, -1);
+		setup_env(loginstr.s, &c);
+		forward(loginstr.s, authdatastr.s, &c);
+		/* does not return */
+#else
+		/* authdata no longer needed */
+		byte_zero(authdatastr.s, authdatastr.len);
+		/* system error, now way out ... module likes to forward
+		   but we don't have support for it. */
+		auth_error(r);
+#endif
+	case NOSUCH: /* FALLTHROUGH */
+	case BADPASS:
+		/* authdata no longer needed */
+		byte_zero(authdatastr.s, authdatastr.len);
+		auth_fail(loginstr.s, r);
+	default:
+		/* authdata no longer needed */
+		byte_zero(authdatastr.s, authdatastr.len);
+		/* system error, now way out ... */
+		auth_error(r);
+	}
+		
+	auth_error(PANIC);
+	return 1; /* should never get here */
+}
+
+void
+chdir_or_make(char *home, char *maildir)
+{
+	char	*md;
+
+	if (maildir == (char *)0 || *maildir == '\0')
+		md = auth_aliasempty();
+	else
+		md = maildir;
+
+	/* ... go to home dir and create it if needed */
+	if (chdir(home) == -1) {
+#ifdef AUTOHOMEDIRMAKE
+		logit(8, "makeing homedir for %s %s\n", home, md);
+
+		switch (dirmaker_make(home, md)) {
+		case OK:
+			break;
+		case MAILDIR_CRASHED:
+			logit(2, "warning: dirmaker failed: program crashed\n");
+			auth_error(MAILDIR_FAILED);
+		case MAILDIR_FAILED:
+			logit(2, "warning: dirmaker failed: bad exit status\n");
+			auth_error(MAILDIR_FAILED);
+		case MAILDIR_UNCONF:
+			logit(2, "warning: dirmaker failed: not configured\n");
+			auth_error(MAILDIR_NONEXIST);
+		case MAILDIR_HARD:
+			logit(2, "warning: dirmaker failed: hard error\n");
+		case ERRNO:
+		default:
+			logit(2, "warning: dirmaker failed (%s)\n",
+			    error_str(errno));
+			auth_error(MAILDIR_FAILED);
+		}
+		if (chdir(home) == -1) {
+			logit(2, "warning: 2nd chdir failed: %s\n",
+			    error_str(errno));
+			auth_error(MAILDIR_FAILED);
+		}
+		logit(32, "homedir successfully made\n");
+#else
+		logit(2, "warning: chdir failed: %s\n", error_str(errno));
+		auth_error(MAILDIR_NONEXIST);
+#endif
+	}
+#ifdef AUTOMAILDIRMAKE
+	switch (maildir_make(md)) {
+	case OK:
+		break;
+	case MAILDIR_CORRUPT:
+		logit(2, "warning: maildir_make failed (%s)\n",
+		    "maildir seems to be corrupt");
+		auth_error(MAILDIR_CORRUPT);
+	case ERRNO:
+	default:
+		logit(2, "warning: maildir_make failed (%s)\n",
+		    error_str(errno));
+		auth_error(MAILDIR_FAILED);
+	}
+#endif
+}
+
+#ifdef QLDAP_CLUSTER
+#define COPY_BUF_SIZE	8192
+static void copyloop(int, int, int, int);
+
+static void
+copyloop(int infdr, int infdw, int outfd, int timeout)
+{
+	fd_set	rfds, wfds;
+	struct	timeval tv;
+	int	maxfd;	/* Maximum numbered fd used */
+	int	r, inpos = 0, outpos = 0;
+	int	inok = 1, outok = 1;
+	char	*inbuf, *outbuf;
+
+	inbuf = alloc(COPY_BUF_SIZE);
+	outbuf = alloc(COPY_BUF_SIZE);
+
+	if (inbuf == (char *)0 || outbuf == (char *)0) {
+		logit(1, "copyloop: %s\n", error_str(errno));
+		close(infdr);
+		close(infdw);
+		close(outfd);
+		return;
+	}
+
+	maxfd = infdr > infdw ? infdr : infdw;
+	maxfd = (maxfd > outfd ? maxfd : outfd) + 1;
+
+	while (1) {
+		/* file descriptor bits */
+		FD_ZERO(&rfds);
+		FD_ZERO(&wfds);
+		if (inok && inpos < COPY_BUF_SIZE)
+			FD_SET(infdr, &rfds);
+		if (outpos != 0)
+			FD_SET(infdw, &wfds);
+		if (outok && outpos < COPY_BUF_SIZE)
+			FD_SET(outfd, &rfds);
+		if (inpos != 0)
+			FD_SET(outfd, &wfds);
+
+		/* Set up timeout */
+		tv.tv_sec = timeout;
+		tv.tv_usec = 0;
+
+		r = select(maxfd, &rfds, &wfds, (fd_set *)0, &tv);
+		if (r == -1) {
+			logit(1, "copyloop: select: %s\n",
+			    error_str(errno));
+			break;
+		} else if (r == 0) {
+			logit(32, "copyloop: select timeout\n");
+			break;
+		}
+
+		if (FD_ISSET(infdr, &rfds)) {
+			if ((r = subread(infdr, inbuf + inpos,
+			    COPY_BUF_SIZE - inpos)) == -1) {
+				if (errno == error_intr) continue;
+				logit(1, "copyloop: read: %s\n",
+				    error_str(errno));
+				break;
+			}
+			if (r == 0)
+				inok = 0;
+			inpos += r;
+		}
+		if (FD_ISSET(outfd, &rfds)) {
+			if ((r = subread(outfd, outbuf + outpos,
+			    COPY_BUF_SIZE - outpos)) == -1) {
+				if (errno == error_intr) continue;
+				logit(1, "copyloop: read: %s\n",
+				    error_str(errno));
+				break;
+			}
+			if (r == 0)
+				outok = 0;
+			outpos += r;
+		}
+		if (FD_ISSET(infdw, &wfds)) {
+			if ((r = subwrite(infdw, outbuf, outpos)) == -1) {
+				if (errno == error_intr) continue;
+				logit(1, "copyloop: write: %s\n",
+				    error_str(errno));
+				break;
+			}
+			if (r != outpos)
+				byte_copy(outbuf, outpos - r, outbuf + r);
+			outpos -= r;
+		}
+		if (FD_ISSET(outfd, &wfds)) {
+			if ((r = subwrite(outfd, inbuf, inpos)) == -1) {
+				if (errno == error_intr) continue;
+				logit(1, "copyloop: write: %s\n",
+				    error_str(errno));
+				break;
+			}
+			if (r != inpos)
+				byte_copy(inbuf, inpos - r, inbuf + r);
+			inpos -= r;
+		}
+
+		if (inok == 0 && inpos == 0)
+			/* half close forwarding channel */
+			shutdown(outfd, SHUT_WR);
+
+		if (outpos == 0 && outok == 0)
+			/*
+			 * Can not half close channel to client so finish the
+			 * communication. Server is no longer intrested anyway.
+			 */
+			break;
+	}
+
+	close(infdr);
+	close(infdw);
+	close(outfd);
+}
+
+void
+forward(char *name, char *passwd, struct credentials *c)
+{
+	struct	ip_address outip;
+	ipalloc	ip = {0};
+	int	ffd;
+	int	timeout = 31*60; /* ~30 min timeout RFC1730 */
+	int	ctimeout = 30;
+	
+	/* pop befor smtp */
+	pbsexec();
+
+	if (!ip_scan("0.0.0.0", &outip))
+		auth_error(ERRNO);
+
+	dns_init(0);
+	switch (dns_ip(&ip,&c->forwarder)) {
+		case DNS_MEM:
+			auth_error(ERRNO);
+		case DNS_SOFT:
+		case DNS_HARD:
+			auth_error(BADCLUSTER);
+		case 1:
+			if (ip.len <= 0)
+				auth_error(BADCLUSTER);
+	}
+	/* 
+	   20010523 Don't check if only one IP is returned, so it is
+	   possible to have a cluster node consisting of multiple machines. 
+	   XXX If your mailhost is bad (bad entries in ldap) you will get
+	   bad loops, the only limit is the tcpserver concurrency limit.
+	   20030627 Could we use the ipme stuff of qmail-remote, to make
+	   single hop loops impossible? Let's try it.
+	 */
+	if (ipme_is(&ip.ix[0].ip) == 1)
+		auth_error(BADCLUSTER);
+
+	ffd = socket(AF_INET, SOCK_STREAM, 0);
+	if (ffd == -1)
+		auth_error(ERRNO);
+	
+	if (timeoutconn(ffd, &ip.ix[0].ip, &outip, auth_port, ctimeout) != 0)
+		auth_error(ERRNO);
+	
+	/* We have a connection, first send user and pass */
+	auth_forward(ffd, name, passwd);
+	copyloop(0, 1, ffd, timeout);
+
+	_exit(0); /* all went ok, exit normaly */
+}
+
+#endif /* QLDAP_CLUSTER */
+
diff -ruN qmail-1.03-orig/auth_mod.h qmail-1.03-ldap-20060201-orig/auth_mod.h
--- qmail-1.03-orig/auth_mod.h	1970-01-01 01:00:00.000000000 +0100
+++ qmail-1.03-ldap-20060201-orig/auth_mod.h	2006-02-25 11:00:55.000000000 +0100
@@ -0,0 +1,76 @@
+/*
+ * Copyright (c) 2000-2004 Claudio Jeker,
+ *      Internet Business Solutions AG, CH-8005 Zürich, Switzerland
+ *
+ * Redistribution and use in source and binary forms, with or without
+ * modification, are permitted provided that the following conditions
+ * are met:
+ * 1. Redistributions of source code must retain the above copyright
+ *    notice, this list of conditions and the following disclaimer.
+ * 2. Redistributions in binary form must reproduce the above copyright
+ *    notice, this list of conditions and the following disclaimer in the
+ *    documentation and/or other materials provided with the distribution.
+ * 3. All advertising materials mentioning features or use of this software
+ *    must display the following acknowledgement:
+ *      This product includes software developed by Internet Business
+ *      Solutions AG and its contributors.
+ * 4. Neither the name of the author nor the names of its contributors
+ *    may be used to endorse or promote products derived from this software
+ *    without specific prior written permission.
+ *
+ * THIS SOFTWARE IS PROVIDED BY THE AUTHORS AND CONTRIBUTORS ``AS IS'' AND
+ * ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE
+ * IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE
+ * ARE DISCLAIMED.  IN NO EVENT SHALL THE AUTHORS OR CONTRIBUTORS BE LIABLE
+ * FOR ANY DIRECT, INDIRECT, INCIDENTAL, SPECIAL, EXEMPLARY, OR CONSEQUENTIAL
+ * DAMAGES (INCLUDING, BUT NOT LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS
+ * OR SERVICES; LOSS OF USE, DATA, OR PROFITS; OR BUSINESS INTERRUPTION)
+ * HOWEVER CAUSED AND ON ANY THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT
+ * LIABILITY, OR TORT (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY
+ * OUT OF THE USE OF THIS SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF
+ * SUCH DAMAGE.
+ *
+ */
+#ifndef __AUTH_MOD_H__
+#define __AUTH_MOD_H__
+
+#include "stralloc.h"
+
+extern const unsigned int auth_port;
+
+/* 
+ * auth_init must return the 0-terminated strings login and authdata.
+ * possible arguments should be parsed and the argument for auth_success
+ * need to be stored if later needed.
+ */
+void auth_init(int, char **, stralloc *, stralloc *);
+
+/*
+ * Checks if it was a hard fail (bad password) or just a soft error 
+ * (user not found). May start an other auth_module. MAY NOT return.
+ */
+void auth_fail(const char *, int);
+
+/* starts the next auth_module, or what ever (argv ... ) */
+void auth_success(const char *);
+
+/*
+ * Error handler, for this module, MAY NOT return.
+ * auth_error MAY be called befor auth_init so it is not possible to
+ * use the argument passed to auth_init in this function.
+ */
+void auth_error(int);
+
+/*
+ * for connection forwarding, makes the login part and returns after 
+ * sending the latest command immidiatly
+ */
+void auth_forward(int fd, char *login, char *passwd);
+
+/*
+ * returns the default maildir if it is not defined, this is normally
+ * the last argument of the execution chain.
+ */
+char *auth_aliasempty(void);
+
+#endif
